/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- База данных: `gameap`
--

-- --------------------------------------------------------

--
-- Структура таблицы `gameap_games`
--

CREATE TABLE IF NOT EXISTS `gameap_games` (
  `code` char(16) NOT NULL,
  `start_code` char(16) NOT NULL,
  `name` tinytext NOT NULL,
  `engine` tinytext NOT NULL,
  `engine_version` char(32) NOT NULL DEFAULT '1',
  `app_id` int(16) NOT NULL,
  `app_set_config` char(64) NOT NULL DEFAULT '',
  `remote_repository` text NOT NULL,
  `local_repository` text NOT NULL,
  PRIMARY KEY (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Дамп данных таблицы `gameap_games`
--

REPLACE INTO `gameap_games` (`code`, `start_code`, `name`, `engine`, `engine_version`, `app_id`, `app_set_config`, `remote_repository`, `local_repository`) VALUES
('ag', 'ag', 'Adrenaline Gamer', 'GoldSource', '1', 90, '', '', ''),
('arma2', 'arma2', 'Arma 2', 'armedassault2', '1', 33905, '', '', ''),
('arma3', 'arma3', 'Arma 3', 'armedassault3', '', 233780, '', '', ''),
('cod4', 'cod4', 'Call of Duty 4', 'cod4', '1', 0, '', '', ''),
('csgo', 'csgo', 'Counter-Strike: Global Offensive', 'Source', '1', 740, '', '', ''),
('cssource', 'cstrike', 'Counter-Strike: Source', 'Source', '1', 232330, '', '', ''),
('cssv34', 'cstrike', 'Counter-Strike: Source v34', 'Source', '1', 0, '', '', ''),
('cstrike', 'cstrike', 'Counter-Strike 1.6', 'GoldSource', '1', 90, '', '', ''),
('czero', 'czero', 'Counter-Strike: Condition Zero', 'GoldSource', '1', 90, '90 mod czero', '', ''),
('dmc', 'dmc', 'Deathmatch Classic', 'GoldSource', '1', 0, '', '', ''),
('dod', 'dod', 'Day of Defeat', 'GoldSource', '1', 90, '90 mod dod', '', ''),
('dods', 'dods', 'Day of Defeat: Source', 'Source', '1', 232290, '', '', ''),
('garrysmod', 'garrysmod', 'Garry''s Mod', 'Source', '1', 4020, '', '', ''),
('gearbox', 'gearbox', 'Half-Life: Opposing Force', 'GoldSource', '1', 90, '90 mod gearbox', '', ''),
('hl2mp', 'hl2mp', 'Half-Life 2', 'Source', '1', 232370, '', '', ''),
('l4d', 'l4d', 'Left 4 Dead', 'Source', '1', 0, '', '', ''),
('l4d2', 'l4d2', 'Left 4 Dead 2', 'Source', '1', 222860, '', '', ''),
('minecraft', 'minecraft', 'Minecraft', 'minecraft', '1', 0, '', '', ''),
('mta', 'mta', 'GTA: Multi Theft Auto', 'mta', '1', 0, '', '', ''),
('ricochet', 'ricochet', 'Ricochet', 'GoldSource', '1', 90, '90 mod ricochet', '', ''),
('rust', 'rust', 'Rust', 'rust', '1', 258550, '', '', ''),
('samp', 'samp', 'GTA: San-Andreas Multiplayer', 'samp', '1', 0, '', '', ''),
('svencoop', 'svencoop', 'Sven Co-op', 'GoldSource', '1', 90, '', '', ''),
('synergy', 'synergy', 'Synergy', 'Source', '1', 17525, '', '', ''),
('tf2', 'tf', 'Team Fortress 2', 'Source', '1', 232250, '', '', ''),
('tfc', 'tfc', 'Team Fortress Classic', 'GoldSource', '1', 90, '90 mod tfc', '', ''),
('valve', 'valve', 'Half-Life 1', 'GoldSource', '1', 90, '', '', '');

-- --------------------------------------------------------

--
-- Структура таблицы `gameap_game_types`
--

CREATE TABLE IF NOT EXISTS `gameap_game_types` (
  `id` int(16) NOT NULL AUTO_INCREMENT,
  `game_code` char(16) NOT NULL,
  `name` tinytext NOT NULL,
  `config_files` text NOT NULL,
  `content_dirs` text NOT NULL,
  `log_dirs` text NOT NULL,
  `fast_rcon` text NOT NULL,
  `aliases` text NOT NULL,
  `disk_size` int(16) NOT NULL,
  `remote_repository` text NOT NULL,
  `local_repository` text NOT NULL,
  `execfile_windows` char(32) NOT NULL,
  `execfile_linux` char(32) NOT NULL,
  `script_start` tinytext NOT NULL,
  `script_stop` tinytext NOT NULL,
  `script_restart` tinytext NOT NULL,
  `script_status` tinytext NOT NULL,
  `script_update` tinytext NOT NULL,
  `script_get_console` tinytext NOT NULL,
  `kick_cmd` varchar(64) NOT NULL DEFAULT '',
  `ban_cmd` varchar(64) NOT NULL DEFAULT '',
  `chname_cmd` varchar(64) NOT NULL DEFAULT '',
  `srestart_cmd` varchar(64) NOT NULL DEFAULT '',
  `chmap_cmd` varchar(64) NOT NULL DEFAULT '',
  `sendmsg_cmd` varchar(64) NOT NULL DEFAULT '',
  `passwd_cmd` varchar(64) NOT NULL DEFAULT '',
  `game_types` tinytext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=38 ;

--
-- Дамп данных таблицы `gameap_game_types`
--

REPLACE INTO `gameap_game_types` (`id`, `game_code`, `name`, `config_files`, `content_dirs`, `log_dirs`, `fast_rcon`, `aliases`, `disk_size`, `remote_repository`, `local_repository`, `execfile_windows`, `execfile_linux`, `script_start`, `script_stop`, `script_restart`, `script_status`, `script_update`, `script_get_console`, `kick_cmd`, `ban_cmd`, `chname_cmd`, `srestart_cmd`, `chmap_cmd`, `sendmsg_cmd`, `passwd_cmd`, `game_types`) VALUES
(1, 'cstrike', 'Standart', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"AMX Maps","file":"cstrike\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true},{"alias":"fps","desc":"FPS","only_admins":true}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban #{id} {time} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(2, 'valve', 'Standart', '[{"desc":"Map Cycle","file":"valve\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"valve\\/server.cfg"},{"desc":"AMX Maps","file":"valve\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"valve\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"valve\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"valve\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"valve\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"valve\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":true},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 50000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(3, 'hl2mp', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"hl2mp\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"hl2mp\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"hl2mp\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"hl2mp\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"hl2mp\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":false}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', 'restart', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(4, 'svencoop', 'Standart', '[{"desc":"Map Cycle","file":"svencoop\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"svencoop\\/server.cfg"},{"desc":"AMX Maps","file":"svencoop\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"svencoop\\/addons\\/metamod\\/plugins.ini"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"svencoop\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"svencoop\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"svencoop\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hlds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayer","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 50000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(5, 'tf2', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"tf\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"tf\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"tf\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"tf\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"tf\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 232250 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(6, 'valve', 'No AmxBans', '[{"desc":"Map Cycle","file":"valve\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"valve\\/server.cfg"},{"desc":"AMX Maps","file":"valve\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"valve\\/motd.txt"},{"desc":"\\u0411\\u0430\\u043d\\u044b SteamID","file":"valve\\/banned.cfg"},{"desc":"\\u0411\\u0430\\u043d\\u044b IP","file":"valve\\/listip.cfg"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"valve\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"valve\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"valve\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"valve\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":true},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(7, 'czero', 'Standart', '[{"desc":"Map Cycle","file":"czero\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"czero\\/server.cfg"},{"desc":"AMX Maps","file":"czero\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"czero\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"czero\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"czero\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"czero\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"\\/cstrike\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"czero\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"czero\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"czero\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(8, 'csgo', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"csgo\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"csgo\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"csgo\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"csgo\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"csgo\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(9, 'valve', 'No AMX MOD X', '[{"desc":"Map Cycle","file":"valve\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"valve\\/server.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"valve\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"valve\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"amx_who"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', 'restart', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(10, 'l4d', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"l4d\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"l4d\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"l4d\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"l4d\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"l4d\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(11, 'cssource', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"cstrike\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', '', 'password {password}', ''),
(12, 'garrysmod', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"gmod\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"gmod\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"gmod\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"gmod\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"gmod\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(13, 'cstrike', 'No AMX MOD X', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayer","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', 'restart', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(14, 'svencoop', 'No AMX MOD X', '[{"desc":"Map Cycle","file":"svencoop\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"svencoop\\/server.cfg"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"svencoop\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"svencoop\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayer","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', 'restart', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(15, 'gearbox', 'Standart', '[{"desc":"Map Cycle","file":"gearbox\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"gearbox\\/server.cfg"},{"desc":"AMX Maps","file":"gearbox\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"gearbox\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"gearbox\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"gearbox\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"gearbox\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"gearbox\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"gearbox\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"gearbox\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"gearbox\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(16, 'gearbox', 'No AMX MOD X', '[{"desc":"Map Cycle","file":"gearbox\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"gearbox\\/server.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"valve\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"gearbox\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayer","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', 'restart', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(17, 'dod', 'Standart', '[{"desc":"Map Cycle","file":"dod\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"dod\\/server.cfg"},{"desc":"AMX Maps","file":"dod\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"dod\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"dod\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"dod\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"dod\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"dod\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"dod\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"dod\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"dod\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(18, 'dods', 'No SourceMod', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"dods\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"dods\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"dods\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"dods\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"dods\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(19, 'dmc', 'Standart', '[{"desc":"Map Cycle","file":"dmc\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"dmc\\/server.cfg"},{"desc":"AMX Maps","file":"dmc\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"dmc\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"dmc\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"dmc\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"dmc\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"dmc\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"dmc\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"dmc\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"dmc\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'start {dir} {name} {ip} {port} "{command}" {user}', 'start {dir} {name} {ip} {port} "{command}" {user}', 'start {dir} {name} {ip} {port} "{command}" {user}', '', 'start {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(20, 'ricochet', 'Standart', '[{"desc":"Map Cycle","file":"ricochet\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"ricochet\\/server.cfg"},{"desc":"AMX Maps","file":"ricochet\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ricochet\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ricochet\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"ricochet\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"ricochet\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"ricochet\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"ricochet\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"ricochet\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"ricochet\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(21, 'minecraft', 'CraftBukkit', '[{"desc":"White list","file":"white-list.txt"},{"desc":"Banned IPs","file":"banned-ips.txt"},{"desc":"Banned Players","file":"banned-players.txt"},{"desc":"Permissions","file":"permissions.yml"},{"desc":"Server properties","file":"server.properties"}]', '[{"desc":"Plugins","path":"plugins","allowed_types":"jar"}]', '', '', '', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', '', '', '', 'reload', '', 'say {msg}', '', '');
REPLACE INTO `gameap_game_types` (`id`, `game_code`, `name`, `config_files`, `content_dirs`, `log_dirs`, `fast_rcon`, `aliases`, `disk_size`, `remote_repository`, `local_repository`, `execfile_windows`, `execfile_linux`, `script_start`, `script_stop`, `script_restart`, `script_status`, `script_update`, `script_get_console`, `kick_cmd`, `ban_cmd`, `chname_cmd`, `srestart_cmd`, `chmap_cmd`, `sendmsg_cmd`, `passwd_cmd`, `game_types`) VALUES
(22, 'ag', 'Standart', '[{"desc":"Map Cycle","file":"ag\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"ag\\/server.cfg"},{"desc":"AMX Maps","file":"ag\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"ag\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"ag\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"ag\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"ag\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"ag\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(23, 'cstrike', 'No AmxBans', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"AMX Maps","file":"cstrike\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"},{"desc":"\\u0411\\u0430\\u043d\\u044b SteamID","file":"banned.cfg"},{"desc":"\\u0411\\u0430\\u043d\\u044b IP","file":"listip.cfg"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"},{"desc":"\\u041c\\u043e\\u0434\\u0435\\u043b\\u0438","path":"cstrike\\/models","allowed_types":"mdl"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":true},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(25, 'rust', 'Standart', '', '', '', '', '[{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false},{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false}]', 0, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 258550 validate +quit', 'get_console {dir} {name} {user}', '', '', '', '', '', '', '', ''),
(26, 'cstrike', 'Standart (Build 5758)', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"AMX Maps","file":"cstrike\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true},{"alias":"fps","desc":"FPS","only_admins":true}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(27, 'valve', 'Standart (Build 5758)', '[{"desc":"Map Cycle","file":"valve\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"valve\\/server.cfg"},{"desc":"AMX Maps","file":"valve\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"valve\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"valve\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"valve\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"valve\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"valve\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"valve\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":true},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 50000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(28, 'cssource', 'Standart', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"cstrike\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"\\u041f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/sourcemod\\/plugins","allowed_types":"smx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', '', 'password {password}', ''),
(29, 'csgo', 'Standart', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"csgo\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"csgo\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"csgo\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"csgo\\/maps","allowed_types":"bsp"},{"desc":"\\u041f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"csgo\\/addons\\/sourcemod\\/plugins","allowed_types":"smx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"csgo\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 740 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(30, 'ag', 'Standart', '[{"desc":"Map Cycle","file":"ag\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"ag\\/server.cfg"},{"desc":"AMX Maps","file":"ag\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"ag\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"ag\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"ag\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"ag\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"ag\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 50000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(31, 'ag', 'Standart (Build 5758)', '[{"desc":"Map Cycle","file":"ag\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"ag\\/server.cfg"},{"desc":"AMX Maps","file":"ag\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"ag\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"ag\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"ag\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"ag\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"ag\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"ag\\/logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"ag\\/addons\\/amxmodx\\/logs","allowed_types":"log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441 \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx Who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"fps","desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0439 FPS","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":false}]', 50000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(32, 'cstrike', 'GunGame', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"AMX Maps","file":"cstrike\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"},{"desc":"GunGame config","file":"cstrike\\/addons\\/amxmodx\\/configs\\/gungame.cfg"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true},{"alias":"fps","desc":"FPS","only_admins":true}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(33, 'cstrike', 'DeathMatch', '[{"desc":"Map Cycle","file":"cstrike\\/mapcycle.txt"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/server.cfg"},{"desc":"AMX Maps","file":"cstrike\\/addons\\/amxmodx\\/configs\\/maps.ini"},{"desc":"MetaMod \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/metamod\\/plugins.ini"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","file":"cstrike\\/addons\\/amxmodx\\/configs\\/plugins.ini"},{"desc":"Dproto config","file":"dproto.cfg"},{"desc":"\\u0410\\u0434\\u043c\\u0438\\u043d\\u0438\\u0441\\u0442\\u0440\\u0430\\u0442\\u043e\\u0440\\u044b AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/users.ini"},{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f AMX","file":"cstrike\\/addons\\/amxmodx\\/configs\\/amxx.cfg"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/motd.txt"},{"desc":"GunGame config","file":"cstrike\\/addons\\/amxmodx\\/configs\\/gungame.cfg"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"AMX \\u043f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/amxmodx\\/plugins","allowed_types":"amxx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"logs","allowed_types":"log"},{"desc":"AMX \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/addons\\/amxmodx\\/logs","allowed_types":"log|txt"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"\\u041e\\u0442\\u043a\\u043b\\u044e\\u0447\\u0438\\u0432\\u0448\\u0438\\u0435\\u0441\\u044f \\u0438\\u0433\\u0440\\u043e\\u043a\\u0438","rcon_command":"amx_last"},{"desc":"Amx who","rcon_command":"amx_who"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"hl_exec","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e hlds_run \\u0438\\u043b\\u0438 hlds.exe)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true},{"alias":"fps","desc":"FPS","only_admins":true}]', 5000, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 90 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', 'amx_ban {time} #{id} {reason}', 'amx_nick #{id} {name}', 'restart', 'changelevel {map}', 'amx_say "{msg}"', 'password {password}', ''),
(34, 'cssv34', 'Standart', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"cstrike\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"cstrike\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"cstrike\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"cstrike\\/maps","allowed_types":"bsp"},{"desc":"\\u041f\\u043b\\u0430\\u0433\\u0438\\u043d\\u044b","path":"cstrike\\/addons\\/sourcemod\\/plugins","allowed_types":"smx"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"cstrike\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true},{"alias":"fps","desc":"FPS","only_admins":true},{"alias":"tickrate","desc":"TickRate","only_admins":true}]', 5000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', '', 'password {password}', ''),
(35, 'tf2', 'Standart', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430","file":"tf\\/cfg\\/server.cfg"},{"desc":"Map Cycle","file":"tf\\/cfg\\/mapcycle.txt"},{"desc":"Motd \\u043e\\u043a\\u043d\\u043e","file":"tf\\/cfg\\/motd.txt"}]', '[{"desc":"\\u041a\\u0430\\u0440\\u0442\\u044b","path":"tf\\/maps","allowed_types":"bsp"}]', '[{"desc":"\\u0421\\u0435\\u0440\\u0432\\u0435\\u0440\\u043d\\u044b\\u0435 \\u043b\\u043e\\u0433\\u0438","path":"tf\\/logs","allowed_types":"txt|log"}]', '[{"desc":"\\u0421\\u0442\\u0430\\u0442\\u0443\\u0441","rcon_command":"status"},{"desc":"Stats","rcon_command":"stats"}]', '[{"alias":"default_map","desc":"\\u041a\\u0430\\u0440\\u0442\\u0430 \\u043f\\u043e \\u0443\\u043c\\u043e\\u043b\\u0447\\u0430\\u043d\\u0438\\u044e","only_admins":false},{"alias":"srcds_run","desc":"\\u0418\\u0441\\u043f\\u043e\\u043b\\u043d\\u044f\\u0435\\u043c\\u044b\\u0439 \\u0444\\u0430\\u0439\\u043b \\u0438\\u0433\\u0440\\u043e\\u0432\\u043e\\u0433\\u043e \\u0441\\u0435\\u0440\\u0432\\u0435\\u0440\\u0430 (\\u043e\\u0431\\u044b\\u0447\\u043d\\u043e srcds_run)","only_admins":true},{"alias":"maxplayers","desc":"\\u041c\\u0430\\u043a\\u0441\\u0438\\u043c\\u0430\\u043b\\u044c\\u043d\\u043e\\u0435 \\u043a\\u043e\\u043b\\u0438\\u0447\\u0435\\u0441\\u0442\\u0432\\u043e \\u0438\\u0433\\u0440\\u043e\\u043a\\u043e\\u0432","only_admins":true}]', 50000, '', '', 'server.exe', './server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '+login anonymous +force_install_dir {dir} +app_update 232250 validate +quit', 'get_console {dir} {name} {user}', 'kick #{id}', '', '', '', 'changelevel {map}', 'say "{msg}"', 'password {password}', ''),
(36, 'samp', 'Standart', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f","file":"server.cfg"}]', '', '', '', '', 0, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', '', '', '', '', '', '', '', ''),
(37, 'mta', 'DeathMatch', '[{"desc":"\\u041a\\u043e\\u043d\\u0444\\u0438\\u0433\\u0443\\u0440\\u0430\\u0446\\u0438\\u044f","file":"mods\\/deathmatch\\/settings.xml"},{"desc":"\\u0411\\u0430\\u043d \\u043b\\u0438\\u0441\\u0442","file":"mods\\/deathmatch\\/banlist.xml"}]', '', '[{"desc":"\\u041b\\u043e\\u0433\\u0438","path":"mods\\/deathmatch\\/logs","allowed_types":"log"}]', '', '', 0, '', '', 'server.exe', 'server.sh', 'start {dir} {name} {ip} {port} "{command}" {user}', 'stop {dir} {name} {ip} {port} "{command}" {user}', 'restart {dir} {name} {ip} {port} "{command}" {user}', 'status {dir} {name} {ip} {port} "{command}" {user}', '', 'get_console {dir} {name} {user}', '', '', '', '', '', '', '', '');

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
